﻿// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated />

namespace Eco.Mods.TechTree
{
        using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Linq;
    using Eco.Core.Items;
    using Eco.Core.Utils;
    using Eco.Core.Utils.AtomicAction;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Property;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Services;
    using Eco.Shared.Utils;
    using Gameplay.Systems.Tooltip;

    [Serialized]
    [LocDisplayName("Electronics")]
    [Ecopedia("Professions", "Engineer", createAsSubPage: true, display: InPageTooltip.DynamicTooltip)]
    [RequiresSkill(typeof(EngineerSkill), 0), Tag("Engineer Specialty"), Tier(4)]
    [Tag("Specialty")]
    public partial class ElectronicsSkill : Skill
    {
        public override LocString DisplayDescription { get { return Localizer.DoStr("Electronics improve the recipes for many advanced materials needed for advanced technology. Level by crafting related recipes."); } }

        public override void OnLevelUp(User user)
        {
            user.Skillset.AddExperience(typeof(SelfImprovementSkill), 20, Localizer.DoStr("for leveling up another specialization."));
        }


        public static MultiplicativeStrategy MultiplicativeStrategy =
            new MultiplicativeStrategy(new float[] { 1,

                1 - 0.5f,

                1 - 0.55f,

                1 - 0.6f,

                1 - 0.65f,

                1 - 0.7f,

                1 - 0.75f,

                1 - 0.8f,

            });
        public override MultiplicativeStrategy MultiStrategy => MultiplicativeStrategy;
        public static AdditiveStrategy AdditiveStrategy =
            new AdditiveStrategy(new float[] { 0,

                0.5f,

                0.55f,

                0.6f,

                0.65f,

                0.7f,

                0.75f,

                0.8f,

            });
        public override AdditiveStrategy AddStrategy => AdditiveStrategy;
        public static int[] SkillPointCost = {

            1,

            1,

            1,

            1,

            1,

            1,

            1,

        };
        public override int RequiredPoint { get { return this.Level < SkillPointCost.Length ? SkillPointCost[this.Level] : 0; } }
        public override int PrevRequiredPoint { get { return this.Level - 1 >= 0 && this.Level - 1 < SkillPointCost.Length ? SkillPointCost[this.Level - 1] : 0; } }
        public override int MaxLevel { get { return 7; } }
        public override int Tier { get { return 4; } }
    }

    [Fuel(25000)][Tag("Fuel")]
    [Tag("Currency")][Currency]
    [Tag("Burnable Fuel", 1)]
    [Serialized]
    [LocDisplayName("Electronics Skill Book")]
    [Ecopedia("Items", "Skill Books", createAsSubPage: true, display: InPageTooltip.DynamicTooltip)]
    public partial class ElectronicsSkillBook : SkillBook<ElectronicsSkill, ElectronicsSkillScroll>
    {
    }

    [Fuel(1)][Tag("Fuel")]
    [Tag("Currency")][Currency]
    [Tag("Burnable Fuel", 1)]
    [Serialized]
    [LocDisplayName("Electronics Skill Scroll")]
    public partial class ElectronicsSkillScroll : SkillScroll<ElectronicsSkill, ElectronicsSkillBook>
    {
    }

    [RequiresSkill(typeof(MechanicsSkill), 1)]
    public partial class ElectronicsSkillScrollRecipe : RecipeFamily
    {
        public ElectronicsSkillScrollRecipe()
        {
            this.Recipes = new List<Recipe>
            {
                new Recipe(
                    "Electronics",
                    Localizer.DoStr("Electronics"),
                    new IngredientElement[]
                    {
               new IngredientElement(typeof(PaperItem), 25),
               new IngredientElement(typeof(MetallurgyResearchPaperAdvancedItem), 10),
               new IngredientElement(typeof(EngineeringResearchPaperModernItem), 10),
               new IngredientElement(typeof(MetallurgyResearchPaperModernItem), 20),
 new IngredientElement("Basic Research", 30),
 new IngredientElement("Advanced Research", 20),
 new IngredientElement("Modern Research", 20),
                    },
                new CraftingElement<ElectronicsSkillScroll>()
                )
            };
            this.LaborInCalories = CreateLaborInCaloriesValue(10000);
            this.CraftMinutes = CreateCraftTimeValue(30);

            this.Initialize(Localizer.DoStr("Electronics Skill Scroll"), typeof(ElectronicsSkillScrollRecipe));
            CraftingComponent.AddRecipe(typeof(ResearchTableObject), this);
        }
    }

    [RequiresSkill(typeof(ElectronicsSkill), 1)]
    public partial class ElectronicsSkillBookRecipe : RecipeFamily
    {
        public ElectronicsSkillBookRecipe()
        {
            this.Recipes = new List<Recipe>
            {
                new Recipe(
                    "ElectronicsBook",
                    Localizer.DoStr("Electronics Book"),
                    new IngredientElement[]
                    {
               new IngredientElement(typeof(PaperItem), 500),
               new IngredientElement(typeof(ElectronicsSkillScroll), 5),
               new IngredientElement(typeof(ElectronicsUpgradeItem), 1),
                    },
                new CraftingElement<ElectronicsSkillBook>()
                )
            };
            this.LaborInCalories = CreateLaborInCaloriesValue(50000);
            this.CraftMinutes = CreateCraftTimeValue(60);

            this.Initialize(Localizer.DoStr("Electronics Skill Book"), typeof(ElectronicsSkillBookRecipe));
            CraftingComponent.AddRecipe(typeof(ResearchTableObject), this);
        }
    }
}
