﻿// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated />

namespace Eco.Mods.TechTree
{
        using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Linq;
    using Eco.Core.Items;
    using Eco.Core.Utils;
    using Eco.Core.Utils.AtomicAction;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Property;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Services;
    using Eco.Shared.Utils;
    using Gameplay.Systems.Tooltip;

    [Serialized]
    [LocDisplayName("Pottery")]
    [Ecopedia("Professions", "Mason", createAsSubPage: true, display: InPageTooltip.DynamicTooltip)]
    [RequiresSkill(typeof(MasonSkill), 0), Tag("Mason Specialty"), Tier(3)]
    [Tag("Specialty")]
    public partial class PotterySkill : Skill
    {
        public override LocString DisplayDescription { get { return Localizer.DoStr("Pottery is an advancement in masonry and can provide an excellent building material for communities. Level by crafting related recipes."); } }

        public override void OnLevelUp(User user)
        {
            user.Skillset.AddExperience(typeof(SelfImprovementSkill), 20, Localizer.DoStr("for leveling up another specialization."));
        }


        public static MultiplicativeStrategy MultiplicativeStrategy =
            new MultiplicativeStrategy(new float[] { 1,

                1 - 0.5f,

                1 - 0.55f,

                1 - 0.6f,

                1 - 0.65f,

                1 - 0.7f,

                1 - 0.75f,

                1 - 0.8f,

            });
        public override MultiplicativeStrategy MultiStrategy => MultiplicativeStrategy;
        public static AdditiveStrategy AdditiveStrategy =
            new AdditiveStrategy(new float[] { 0,

                0.5f,

                0.55f,

                0.6f,

                0.65f,

                0.7f,

                0.75f,

                0.8f,

            });
        public override AdditiveStrategy AddStrategy => AdditiveStrategy;
        public static int[] SkillPointCost = {

            1,

            1,

            1,

            1,

            1,

            1,

            1,

        };
        public override int RequiredPoint { get { return this.Level < SkillPointCost.Length ? SkillPointCost[this.Level] : 0; } }
        public override int PrevRequiredPoint { get { return this.Level - 1 >= 0 && this.Level - 1 < SkillPointCost.Length ? SkillPointCost[this.Level - 1] : 0; } }
        public override int MaxLevel { get { return 7; } }
        public override int Tier { get { return 3; } }
    }

    [Fuel(25000)][Tag("Fuel")]
    [Tag("Currency")][Currency]
    [Tag("Burnable Fuel", 1)]
    [Serialized]
    [LocDisplayName("Pottery Skill Book")]
    [Ecopedia("Items", "Skill Books", createAsSubPage: true, display: InPageTooltip.DynamicTooltip)]
    public partial class PotterySkillBook : SkillBook<PotterySkill, PotterySkillScroll>
    {
    }

    [Fuel(1)][Tag("Fuel")]
    [Tag("Currency")][Currency]
    [Tag("Burnable Fuel", 1)]
    [Serialized]
    [LocDisplayName("Pottery Skill Scroll")]
    public partial class PotterySkillScroll : SkillScroll<PotterySkill, PotterySkillBook>
    {
    }

    [RequiresSkill(typeof(MasonrySkill), 1)]
    public partial class PotterySkillScrollRecipe : RecipeFamily
    {
        public PotterySkillScrollRecipe()
        {
            this.Recipes = new List<Recipe>
            {
                new Recipe(
                    "Pottery",
                    Localizer.DoStr("Pottery"),
                    new IngredientElement[]
                    {
               new IngredientElement(typeof(PaperItem), 25),
               new IngredientElement(typeof(GeologyResearchPaperBasicItem), 10),
               new IngredientElement(typeof(GeologyResearchPaperAdvancedItem), 5),
               new IngredientElement(typeof(EngineeringResearchPaperAdvancedItem), 5),
 new IngredientElement("Basic Research", 10),
                    },
                new CraftingElement<PotterySkillScroll>()
                )
            };
            this.LaborInCalories = CreateLaborInCaloriesValue(4000);
            this.CraftMinutes = CreateCraftTimeValue(15);

            this.Initialize(Localizer.DoStr("Pottery Skill Scroll"), typeof(PotterySkillScrollRecipe));
            CraftingComponent.AddRecipe(typeof(ResearchTableObject), this);
        }
    }

    [RequiresSkill(typeof(PotterySkill), 1)]
    public partial class PotterySkillBookRecipe : RecipeFamily
    {
        public PotterySkillBookRecipe()
        {
            this.Recipes = new List<Recipe>
            {
                new Recipe(
                    "PotteryBook",
                    Localizer.DoStr("Pottery Book"),
                    new IngredientElement[]
                    {
               new IngredientElement(typeof(PaperItem), 500),
               new IngredientElement(typeof(PotterySkillScroll), 5),
               new IngredientElement(typeof(PotteryUpgradeItem), 1),
                    },
                new CraftingElement<PotterySkillBook>()
                )
            };
            this.LaborInCalories = CreateLaborInCaloriesValue(50000);
            this.CraftMinutes = CreateCraftTimeValue(60);

            this.Initialize(Localizer.DoStr("Pottery Skill Book"), typeof(PotterySkillBookRecipe));
            CraftingComponent.AddRecipe(typeof(ResearchTableObject), this);
        }
    }
}
