﻿// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated />

namespace Eco.Mods.TechTree
{
        using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Linq;
    using Eco.Core.Items;
    using Eco.Core.Utils;
    using Eco.Core.Utils.AtomicAction;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Property;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Services;
    using Eco.Shared.Utils;
    using Gameplay.Systems.Tooltip;

    [Serialized]
    [LocDisplayName("Tailoring")]
    [Ecopedia("Professions", "Tailor", createAsSubPage: true, display: InPageTooltip.DynamicTooltip)]
    [RequiresSkill(typeof(TailorSkill), 0), Tag("Tailor Specialty"), Tier(2)]
    [Tag("Specialty")]
    public partial class TailoringSkill : Skill
    {
        public override LocString DisplayDescription { get { return Localizer.DoStr("Creating new clothes and setting trends. Level by crafting related recipes."); } }

        public override void OnLevelUp(User user)
        {
            user.Skillset.AddExperience(typeof(SelfImprovementSkill), 20, Localizer.DoStr("for leveling up another specialization."));
        }


        public static MultiplicativeStrategy MultiplicativeStrategy =
            new MultiplicativeStrategy(new float[] { 1,

                1 - 0.5f,

                1 - 0.55f,

                1 - 0.6f,

                1 - 0.65f,

                1 - 0.7f,

                1 - 0.75f,

                1 - 0.8f,

            });
        public override MultiplicativeStrategy MultiStrategy => MultiplicativeStrategy;
        public static AdditiveStrategy AdditiveStrategy =
            new AdditiveStrategy(new float[] { 0,

                0.5f,

                0.55f,

                0.6f,

                0.65f,

                0.7f,

                0.75f,

                0.8f,

            });
        public override AdditiveStrategy AddStrategy => AdditiveStrategy;
        public static int[] SkillPointCost = {

            1,

            1,

            1,

            1,

            1,

            1,

            1,

        };
        public override int RequiredPoint { get { return this.Level < SkillPointCost.Length ? SkillPointCost[this.Level] : 0; } }
        public override int PrevRequiredPoint { get { return this.Level - 1 >= 0 && this.Level - 1 < SkillPointCost.Length ? SkillPointCost[this.Level - 1] : 0; } }
        public override int MaxLevel { get { return 7; } }
        public override int Tier { get { return 2; } }
    }

    [Fuel(25000)][Tag("Fuel")]
    [Tag("Currency")][Currency]
    [Tag("Burnable Fuel", 1)]
    [Serialized]
    [LocDisplayName("Tailoring Skill Book")]
    [Ecopedia("Items", "Skill Books", createAsSubPage: true, display: InPageTooltip.DynamicTooltip)]
    public partial class TailoringSkillBook : SkillBook<TailoringSkill, TailoringSkillScroll>
    {
    }

    [Fuel(1)][Tag("Fuel")]
    [Tag("Currency")][Currency]
    [Tag("Burnable Fuel", 1)]
    [Serialized]
    [LocDisplayName("Tailoring Skill Scroll")]
    public partial class TailoringSkillScroll : SkillScroll<TailoringSkill, TailoringSkillBook>
    {
    }

    [RequiresSkill(typeof(GatheringSkill), 0)]
    public partial class TailoringSkillScrollRecipe : RecipeFamily
    {
        public TailoringSkillScrollRecipe()
        {
            this.Recipes = new List<Recipe>
            {
                new Recipe(
                    "Tailoring",
                    Localizer.DoStr("Tailoring"),
                    new IngredientElement[]
                    {
               new IngredientElement(typeof(PaperItem), 25),
               new IngredientElement(typeof(GatheringResearchPaperBasicItem), 5),
 new IngredientElement("Basic Research", 5),
                    },
                new CraftingElement<TailoringSkillScroll>()
                )
            };
            this.LaborInCalories = CreateLaborInCaloriesValue(1000);
            this.CraftMinutes = CreateCraftTimeValue(5);

            this.Initialize(Localizer.DoStr("Tailoring Skill Scroll"), typeof(TailoringSkillScrollRecipe));
            CraftingComponent.AddRecipe(typeof(ResearchTableObject), this);
        }
    }

    [RequiresSkill(typeof(TailoringSkill), 1)]
    public partial class TailoringSkillBookRecipe : RecipeFamily
    {
        public TailoringSkillBookRecipe()
        {
            this.Recipes = new List<Recipe>
            {
                new Recipe(
                    "TailoringBook",
                    Localizer.DoStr("Tailoring Book"),
                    new IngredientElement[]
                    {
               new IngredientElement(typeof(PaperItem), 500),
               new IngredientElement(typeof(TailoringSkillScroll), 5),
               new IngredientElement(typeof(TailoringUpgradeItem), 1),
                    },
                new CraftingElement<TailoringSkillBook>()
                )
            };
            this.LaborInCalories = CreateLaborInCaloriesValue(50000);
            this.CraftMinutes = CreateCraftTimeValue(60);

            this.Initialize(Localizer.DoStr("Tailoring Skill Book"), typeof(TailoringSkillBookRecipe));
            CraftingComponent.AddRecipe(typeof(ResearchTableObject), this);
        }
    }
}
