﻿namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Shared.Utils;
    using Eco.World;
    using Eco.World.Blocks;
    using Gameplay.Systems.TextLinks;
    using Eco.Shared.Localization;

    public partial class BasicPaperRecipe :
        RecipeFamily
    {
        public BasicPaperRecipe()
        {
            this.Recipes = new List<Recipe>
            {
                new Recipe(
                    "Paper",
                    Localizer.DoStr("Paper"),
                    new IngredientElement[]
                    {
                        new IngredientElement("NaturalFiber", 30, true),
                    },
                    new CraftingElement[]
                    {
                        new CraftingElement<PaperItem>(),
                    }
                )
            };
            this.ExperienceOnCraft = 0;
            this.LaborInCalories = CreateLaborInCaloriesValue(50);
            this.CraftMinutes = CreateCraftTimeValue(1);
            this.Initialize(Localizer.DoStr("Paper"), typeof(BasicPaperRecipe));

            CraftingComponent.AddRecipe(typeof(WorkbenchObject), this);
        }
    }
}
