﻿namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Objects;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.Core.Items;
    using Eco.World;
    using Eco.World.Blocks;
    using Eco.Gameplay.Pipes;

    public partial class CulinaryResearchPaperAdvancedMeatRecipe :
        RecipeFamily
    {
        partial void ModsPreInitialize()
        {
            this.Recipes = new List<Recipe>
            {
                new Recipe(
                    "CulinaryResearchPaperAdvancedMeat",
                    Localizer.DoStr("Culinary Research Paper Advanced"),
                    new IngredientElement[]
                    {
                    new IngredientElement(typeof(PaperItem), 10, true),
                    new IngredientElement(typeof(CulinaryResearchPaperBasicItem), 10, typeof(BakingSkill), typeof(BakingLavishResourcesTalent)), 
                    new IngredientElement(typeof(MetallurgyResearchPaperBasicItem), 5, typeof(BakingSkill), typeof(BakingLavishResourcesTalent)), 
                    new IngredientElement(typeof(BakedMeatItem), 10, typeof(BakingSkill), typeof(BakingLavishResourcesTalent)), 
                    new IngredientElement(typeof(SimmeredMeatItem), 5, typeof(BakingSkill), typeof(BakingLavishResourcesTalent)),    
                    },
                    new CraftingElement[]
                    {
                    new CraftingElement<CulinaryResearchPaperAdvancedItem>(), 
                    }
                )
            };
        }
    }
}
