﻿namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Shared.Utils;
    using Eco.World;
    using Eco.World.Blocks;
    using Gameplay.Systems.TextLinks;
    using Eco.Shared.Localization;

    public partial class HewnLogToWoodPulpRecipe :
        RecipeFamily
    {
        public HewnLogToWoodPulpRecipe()
        {
            this.Recipes = new List<Recipe>
            {
                new Recipe(
                    "WoodPulp",
                    Localizer.DoStr("Wood Pulp"),
                    new IngredientElement[]
                    {
                        new IngredientElement("HewnLog", 1, true),
                    },
                    new CraftingElement[]
                    {
                        new CraftingElement<WoodPulpItem>(50),
                    }
                )
            };
            this.ExperienceOnCraft = 0;
            this.LaborInCalories = CreateLaborInCaloriesValue(35);
            this.CraftMinutes = CreateCraftTimeValue(0.2f);
            this.Initialize(Localizer.DoStr("Wood Pulp"), typeof(HewnLogToWoodPulpRecipe));

            CraftingComponent.AddRecipe(typeof(WorkbenchObject), this);
        }
    }
}
