﻿namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Shared.Utils;
    using Eco.World;
    using Eco.World.Blocks;
    using Gameplay.Systems.TextLinks;
    using Eco.Shared.Localization;

    [RequiresSkill(typeof(PaperMillingSkill), 1)]
    public partial class HewnLogToWoodPulpLv2Recipe :
        RecipeFamily
    {
        public HewnLogToWoodPulpLv2Recipe()
        {
            this.Recipes = new List<Recipe>
            {
                new Recipe(
                    "WoodPulp",
                    Localizer.DoStr("Wood Pulp"),
                    new IngredientElement[]
                    {
                        new IngredientElement("HewnLog", 1, typeof(PaperMillingSkill), typeof(PaperMillingLavishResourcesTalent)),
                    },
                    new CraftingElement[]
                    {
                        new CraftingElement<WoodPulpItem>(50),
                    }
                )
            };
            this.ExperienceOnCraft = 0.5f;
            this.LaborInCalories = CreateLaborInCaloriesValue(35, typeof(PaperMillingSkill));
            this.CraftMinutes = CreateCraftTimeValue(typeof(WoodToCelluloseFiberRecipe), 0.2f, typeof(PaperMillingSkill), typeof(PaperMillingFocusedSpeedTalent), typeof(PaperMillingParallelSpeedTalent));
            this.Initialize(Localizer.DoStr("Wood Pulp"), typeof(HewnLogToWoodPulpLv2Recipe));

            CraftingComponent.AddRecipe(typeof(WorkbenchObject), this);
        }
    }
}
