﻿namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Shared.Utils;
    using Eco.World;
    using Eco.World.Blocks;
    using Gameplay.Systems.TextLinks;
    using Eco.Shared.Localization;

    [RequiresSkill(typeof(PaperMillingSkill), 2)]
    public partial class WoodToCelluloseFiberRecipe :
        RecipeFamily
    {
        public WoodToCelluloseFiberRecipe()
        {
            this.Recipes = new List<Recipe>
            {
                new Recipe(
                    "CelluloseFiber",
                    Localizer.DoStr("Cellulose Fiber"),
                    new IngredientElement[]
                    {
                        new IngredientElement("HewnLog", 1, typeof(PaperMillingSkill), typeof(PaperMillingLavishResourcesTalent)),
                    },
                    new CraftingElement[]
                    {
                        new CraftingElement<CelluloseFiberItem>(2),
                    }
                )
            };
            this.ExperienceOnCraft = 1;
            this.LaborInCalories = CreateLaborInCaloriesValue(100, typeof(PaperMillingSkill));
            this.CraftMinutes = CreateCraftTimeValue(typeof(WoodToCelluloseFiberRecipe), 2, typeof(PaperMillingSkill), typeof(PaperMillingFocusedSpeedTalent), typeof(PaperMillingParallelSpeedTalent));
            this.Initialize(Localizer.DoStr("Cellulose Fiber"), typeof(WoodToCelluloseFiberRecipe));

            CraftingComponent.AddRecipe(typeof(CarpentryTableObject), this);
        }
    }
}
