﻿namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Shared.Utils;
    using Eco.World;
    using Eco.World.Blocks;
    using Gameplay.Systems.TextLinks;
    using Eco.Shared.Localization;

    [RequiresSkill(typeof(PaperMillingSkill), 4)]
    public partial class WoodToPaperRecipe :
        RecipeFamily
    {
        public WoodToPaperRecipe()
        {
            this.Recipes = new List<Recipe>
            {
                new Recipe(
                    "Paper",
                    Localizer.DoStr("Paper"),
                    new IngredientElement[]
                    {
                        new IngredientElement("HewnLog", 1, typeof(PaperMillingSkill), typeof(PaperMillingLavishResourcesTalent)),
                    },
                    new CraftingElement[]
                    {
                        new CraftingElement<PaperItem>(2),
                    }
                )
            };
            this.ExperienceOnCraft = 1;
            this.LaborInCalories = CreateLaborInCaloriesValue(300, typeof(PaperMillingSkill));
            this.CraftMinutes = CreateCraftTimeValue(typeof(WoodToPaperRecipe), 3, typeof(PaperMillingSkill), typeof(PaperMillingFocusedSpeedTalent), typeof(PaperMillingParallelSpeedTalent));
            this.Initialize(Localizer.DoStr("Paper"), typeof(WoodToPaperRecipe));

            CraftingComponent.AddRecipe(typeof(CarpentryTableObject), this);
        }
    }
}
